import qt
import urllib2
import ssl
import cookielib
import xml.etree.ElementTree as ET
import re
import StringIO

class slicerNetwork:
    def __init__(self,parent):
        parent.title = "slicerNetwork"
        self.parent=parent

    def configureSSL(self,cert,key,pwd,cacert):
        #do this first
        self.ctx=ssl.SSLContext(ssl.PROTOCOL_SSLv23)
        self.ctx.load_cert_chain(cert,key,pwd)
        self.ctx.verify_mode=ssl.CERT_REQUIRED
        self.ctx.load_verify_locations(cacert)

    def connectRemote(self,serverUrl,uname,pwd):
        https_handler=urllib2.HTTPSHandler(context=self.ctx)

        #cookie part
        cj=cookielib.CookieJar()
        cookie_handler=urllib2.HTTPCookieProcessor(cj)

        self.opener=urllib2.build_opener(https_handler,cookie_handler)
        loginUrl=serverUrl+"/labkey/login/login.post"
        r=urllib2.Request(str(loginUrl))
        print "Connecting to {0}".format(loginUrl)
        r.add_header('ContentType','application/x-www-form-urlencoded')
        data="email="+uname+"&password="+pwd
        r.add_data(data)

        self.opener.open(r)

        #cj in opener contains the cookies

    def get(self,url):

        #r1=urllib2.Request('https://merlin.fmf.uni-lj.si/labkey/query/motionData/selectRows.api?schemaName=core&query.queryName=Users')
        r=urllib2.Request(url)
        return self.opener.open(r)
        #f contains json as a return value

    def post(self,url,data):

        r=urllib2.Request(url)
        #makes it a post
        r.add_data(data)
        r.add_header("content-type","application/json")

        f=self.opener.open(r)
        #f contains json as a return value

    def listDir(self,serverUrl,dir):
        dirUrl=serverUrl+"/labkey/_webdav"+"/"+dir
        r=propfindRequest(dirUrl)
        PROPFIND=u"""<?xml version="1.0" encoding="utf-8"?>\n
                    <propfind xmlns="DAV:">\n
                    <prop>\n
                    <getetag/>\n
                    </prop>\n
                    </propfind>"""
        r.add_header('content-type','text/xml; charset="utf-8"')
        r.add_header('content-length',str(len(PROPFIND)))
        r.add_header('Depth','1')
        r.add_data(PROPFIND)
        f=self.opener.open(r)
        tree=ET.XML(f.read())
        rps=tree.findall('{DAV:}response')
        dirs=[]
        for r in rps:
            hr=r.find('{DAV:}href')
            dirent=hr.text
            dirent=re.sub('/labkey/_webdav/','',dirent)
            dirs.append(dirent)
        del dirs[0]
        return dirs

    def readFile(self, serverUrl, path):
        dirUrl=serverUrl+"/labkey/_webdav"+"/"+path
        f=self.get(dirUrl)
        return StringIO.StringIO(f.read())
        
class propfindRequest(urllib2.Request):
    """
    This request subclass allows explicit specification of
    the HTTP request method. Basic urllib2.Request class
    chooses GET or POST depending on self.has_data()
    """
    def __init__(self, *args, **kwargs):
        #self.method = 'Propfind'
        urllib2.Request.__init__(self, *args, **kwargs)

    def get_method(self):
        return 'PROPFIND'
